#!/usr/bin/perl

# Compute the batcher networks and print their sizes.
# Modified from the example batcher04.t included in the Algorithm::Networksort
# perl module distribution.
# 
# Usage: batcher.pl

# Add directory to the @INC search directory list.
use lib '/home/vkv/work/Algorithm-Networksort/lib';
use lib '/home/vkv/work/Algorithm-Networksort/t';

use Getopt::Long;
use Algorithm::Networksort ':all';

use strict;
use warnings;

use Test::Simple tests => 21;

require "zero_one.pl";

my $algorithm = 'batcher';
my @network;
my $status;
my $size;

for my $inputs (1..21)
{
	@network = nw_comparators($inputs, algorithm=>$algorithm);
	$status = zero_one($inputs, \@network);
	$size = @network;
	if ($status eq "pass")
	{
		ok(1, "$algorithm, N=$inputs, C=$size");
	}
	else
	{
		ok(0, "$algorithm, N=$inputs, $status");
	}
}

