#!/usr/bin/perl

# List the comparators of the sorting network in beagle.log
# for inclusion in latex.
#
# Usage: comparators.pl beagle.log

# Add directory to the @INC search directory list.
use lib '/home/vkv/work/Algorithm-Networksort/lib';
use lib '/home/vkv/work/Algorithm-Networksort/t';

use Getopt::Long;
use Algorithm::Networksort ':all';

use strict;
use warnings;

my $genotype = 0;
while (<>) {
    $genotype = 1 if /Genotype/;
    if ($genotype && /<Comparators.+>(.+)<\/Comparators>/) {
        my @compvec = split ";", $1;
        for (my $i = 0; $i < @compvec/2; $i++) {
	    my $line1 = $compvec[2*$i]+1;
	    my $line2 = $compvec[2*$i+1]+1;
	    print "[$line1,~$line2], ";
        }
        last;
    }
}
print "\n";

