#!/usr/bin/perl

# Make a Latex figure environment for the sorting network in beagle.log.
#
# Usage: latexfig.pl beagle.log

# Add directory to the @INC search directory list.
use lib '/home/vkv/work/Algorithm-Networksort/lib';
use lib '/home/vkv/work/Algorithm-Networksort/t';

use Getopt::Long;
use Algorithm::Networksort ':all';

use strict;
use warnings;

my $genotype = 0;
my $inputs = 0;
my $numcomparators = 0;
my $string = "";
while (<>) {
    $genotype = 1 if /Genotype/;
    $inputs = $1 if $genotype && /numInputs="(\d+)"/;
    if ($genotype && /<Comparators.+>(.+)<\/Comparators>/) {
        my @compvec = split ";", $1;
        $numcomparators = @compvec/2;
        for (my $i = 0; $i < $numcomparators; $i++) {
	    my $line1 = $compvec[2*$i]+1;
	    my $line2 = $compvec[2*$i+1]+1;
	    $string .= "[$line1,~$line2]";
            $string .= ", " if $i < $numcomparators - 1;
        }
        last;
    }
}

print "\\begin{figure}\n";
print "  \\centering\n";
print "  \\includegraphics[scale=1]{figs/sorting-network-$inputs-eda.pdf}\n";
print "  \\caption{\\textbf{$inputs-input network with $numcomparators comparators:}\n";
print "    $string.}\n";
print "\\end{figure}\n";

