
/*!
 *  \file   beagle/NN/StatsCalcFitnessIndexedOp.hpp
 *  \brief  Definition of the class StatsCalcFitnessIndexedOp.
 *  \author Vinod Valsalam
 *  $Revision: $
 *  $Date: $
 */

#ifndef Beagle_StatsCalcFitnessIndexedOp_hpp
#define Beagle_StatsCalcFitnessIndexedOp_hpp

#include "beagle/config.hpp"
#include "beagle/macros.hpp"
#include "beagle/Object.hpp"
#include "beagle/Pointer.hpp"
#include "beagle/PointerT.hpp"
#include "beagle/Allocator.hpp"
#include "beagle/AllocatorT.hpp"
#include "beagle/Container.hpp"
#include "beagle/ContainerT.hpp"
#include "beagle/WrapperT.hpp"
#include "beagle/Operator.hpp"
#include "beagle/Stats.hpp"
#include "beagle/Vivarium.hpp"
#include "beagle/Context.hpp"
#include "beagle/StatsCalculateOp.hpp"

namespace Beagle
{
namespace NN
{


/*!
 *  \class StatsCalcFitnessIndexedOp beagle/NN/StatsCalcFitnessIndexedOp.hpp
 *     "beagle/NN/StatsCalcFitnessIndexedOp.hpp"
 *  \brief Statistics calculation operator class for fitness of type FitnessIndexed.
 *  \ingroup NNF
 */
class StatsCalcFitnessIndexedOp : public StatsCalculateOp
{

public:

	//! StatsCalcFitnessIndexedOp allocator type
	typedef AllocatorT<StatsCalcFitnessIndexedOp,StatsCalculateOp::Alloc>
	Alloc;
	//! StatsCalcFitnessIndexedOp handle type.
	typedef PointerT<StatsCalcFitnessIndexedOp,StatsCalculateOp::Handle>
	Handle;
	//! StatsCalcFitnessIndexedOp bag type.
	typedef ContainerT<StatsCalcFitnessIndexedOp,StatsCalculateOp::Bag>
	Bag;

	explicit StatsCalcFitnessIndexedOp(std::string inName="NN-StatsCalcFitnessIndexedOp");
	virtual ~StatsCalcFitnessIndexedOp()
	{ }

	virtual void calculateStatsDeme(Beagle::Stats& outStats, Beagle::Deme& ioDeme, Beagle::Context& ioContext) const;
	virtual void operate(Beagle::Deme& ioDeme, Beagle::Context& ioContext);

};

}
}

#endif // Beagle_StatsCalcFitnessIndexedOp.cpp_hpp

