/*
 *  Open BEAGLE
 *  Copyright (C) 2001-2005 by Christian Gagne and Marc Parizeau
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Contact:
 *  Laboratoire de Vision et Systemes Numeriques
 *  Departement de genie electrique et de genie informatique
 *  Universite Laval, Quebec, Canada, G1K 7P4
 *  http://vision.gel.ulaval.ca
 *
 */

/*!
 *  \file   beagle/SN.hpp
 *  \brief  File to include to import all the SN specific Beagle classes.
 *  \author Vinod Valsalam
 *  $Revision: $
 *  $Date: $
 */

/*!
 *  \namespace Beagle::SN
 *  \brief     Namespace of all the classes of the Open Beagle SN framework.
 *  \ingroup SNF
 */

/*!
 *  \defgroup SNF SN Framework
 *  \brief Specialized framework for evolving sorting networks.
 *
 *  TODO Fill in a detailed description of the framework.
 *
 */

#ifndef Beagle_SN_hpp
#define Beagle_SN_hpp


// Beagle generic components

#include "beagle/Beagle.hpp"

// SN framework

#include "beagle/SN/AlgoDummy.hpp"
#include "beagle/SN/EstimateReconstructOp.hpp"
#include "beagle/SN/EvaluationOp.hpp"
#include "beagle/SN/Function.hpp"
#include "beagle/SN/Individual.hpp"
#include "beagle/SN/InitializationOp.hpp"
#include "beagle/SN/MutationAddComparatorOp.hpp"
#include "beagle/SN/MutationTruncateConstructOp.hpp"
#include "beagle/SN/Network.hpp"
#include "beagle/SN/PackageBase.hpp"
#include "beagle/SN/TermSortedOp.hpp"
#include "beagle/SN/Utilities.hpp"


#endif // Beagle_SN_hpp

