
/*!
 *  \file   beagle/SN/AlgoDummy.hpp
 *  \brief  Definition of the class SN::AlgoDummy.
 *  \author Vinod Valsalam
 *  $Revision: $
 *  $Date: $
 */

#ifndef Beagle_SN_AlgoDummy_hpp
#define Beagle_SN_AlgoDummy_hpp

#include <string>

#include "beagle/config.hpp"
#include "beagle/macros.hpp"
#include "beagle/Algorithm.hpp"


namespace Beagle
{
namespace SN
{

/*!
 *  \class AlgoDummy beagle/SN/AlgoDummy.hpp "beagle/SN/AlgoDummy.hpp"
 *  \brief Implements a dummy algorithm class that does nothing.
 *  \ingroup SNF
 */
class AlgoDummy : public Algorithm
{

public:

	//! AlgoDummy allocator type.
	typedef AllocatorT< AlgoDummy, Algorithm::Alloc > Alloc;
	//! AlgoDummy handle type.
	typedef PointerT< AlgoDummy, Algorithm::Handle > Handle;
	//! AlgoDummy bag type.
	typedef ContainerT< AlgoDummy, Algorithm::Bag > Bag;

	AlgoDummy();
	virtual ~AlgoDummy()
	{ }

	virtual void configure(Evolver& ioEvolver, System& ioSystem);

};

}
}

#endif // Beagle_SN_AlgoDummy_hpp
