/*
 *  Co-evolutionary Symbolic Regression (coev_symbreg):
 *  Mixed real-valued GA - GP co-evolution example with Open BEAGLE
 *
 *  Copyright (C) 2003-2006 by Christian Gagne and Jiachuan Wang
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *  Contact:
 *  Laboratoire de Vision et Systemes Numeriques
 *  Departement de genie electrique et de genie informatique
 *  Universite Laval, Quebec, Canada, G1K 7P4
 *  http://vision.gel.ulaval.ca
 *
 */

/*!
 *  \file   SymGPThread.hpp
 *  \brief  Declaration of the class SymGPThread.
 *  \author Jiachuan Wang <jiacwang@ecs.umass.edu>
 *  \author Christian Gagne <cgagne@gmail.com>
 *  $Revision: 1.13 $
 *  $Date: 2007/08/10 20:32:22 $
 */

#ifndef SymGPThread_hpp
#define SymGPThread_hpp

#include "beagle/Coev.hpp"
#include "PACC/Threading.hpp"
#include <vector>


/*!
 *  \class SymGPThread SymGPThread.hpp "SymGPThread.hpp"
 *  \brief Co-evolution thread class for the GP population.
 *  \ingroup CoSym
 */
class SymGPThread : public PACC::Threading::Thread
{

public:
	SymGPThread(std::string inConfigFilename="symgp-thread.conf");
	~SymGPThread();

protected:
	virtual void main();

	std::string mConfigFilename;   //!< Configuration filename

};

#endif // SymGPThread_hpp

