#include <iostream>
#include <string>
#include "beagle/Beagle.hpp"
#include "beagle/Distrib/Island.hpp"
#include "PACC/Socket.hpp"


using namespace std;
using namespace Beagle;
using namespace Beagle::Distrib;

/*!
 *  \brief Send message via Communications system component.
 *
 */
int main(int argc, char** argv)
{
	// Check there are at least four arguments
	if (argc < 5) {
		cout << "Usage error:" << endl
		<< "  sendMessage <ip_addy> <port_num> <recipient> <message> [-OB...]" << endl;
		return 1; // error
	}

	// Get command line arguments
	std::string lIPAddy = argv[1];
	unsigned int lPortNum = Beagle::str2uint(argv[2]);
	std::string lRecipient = argv[3];
	std::string lMessage = argv[4];

	// Display command line arguments
	cout << "IP Address  = " << lIPAddy << endl
	<< "Port Number = " << lPortNum << endl
	<< "Recipient   = " << lRecipient << endl
	<< "Message     = " << lMessage << endl;

	// Set up Beagle
	System::Handle lSystem = new System;
	Island::CommunicationsTCPIP::Handle lComms = new Island::CommunicationsTCPIP;
	lSystem->addComponent(lComms);
	lSystem->initialize(argc,argv);
	lSystem->initComponents();
	Context lContext;
	lContext.setSystemHandle(lSystem);

	// Add the address and send the message
	lComms->addAddress( "target", PACC::Socket::Address(lPortNum, lIPAddy) );
	lComms->sendMessage( "target", lRecipient, lMessage, lContext );
}
