#include <iostream>
#include "beagle/Beagle.hpp"
#include "beagle/Distrib/Island.hpp"
#include "Test.hpp"

using namespace std;
using namespace Beagle;
using namespace Beagle::Distrib;

/*!
 *  \brief Test Communications system component
 */
int main(int argc, char** argv)
{
	try {
		Beagle_StackTraceBeginM();
		Island::CommunicationsTCPIP::Handle lComms = new Island::CommunicationsTCPIP(4500);

		// Initialize
		System::Handle lSystem = new System;
		Deme lDeme;
		Context lContext;
		lContext.setSystemHandle(lSystem);
		lSystem->addComponent( lComms );
		lSystem->initialize(argc, argv);
		lSystem->initComponents();

		PACC::Threading::Thread::sleep(1.);  // Give the server thread time to start up

		// Send message
		PACC::Socket::Address lAddress(4500,"127.0.0.1");
		lComms->addAddress("target",lAddress);

		lComms->sendMessage( "target",
		                     "test",
		                     "This is a test.",
		                     lContext );

		// Give some time to send message
		PACC::Threading::Thread::sleep(1.);

		// Handle messages
		lComms->getMessages(lContext);
		std::string lMessage;
		while(lComms->getNextMessage("test",lMessage,lContext)) {
			cout << "\n\nMessage is '" << lMessage << "'" << endl;
		}

		Beagle_StackTraceEndM("int main(int, char**)");
	}
	Beagle_Test_CatchEverythingM;
}
