
/*!
 *  \file   network.h
 *  \author Vinod Valsalam
 */

#ifndef network_h
#define network_h

#include <inttypes.h>


typedef struct {
    uint8_t     source;             // id of the source node of the edge
    double      weight;             // weight of the edge
} Edge;


typedef struct {
    double      bias;               // bias of the sigmoid
    double      slope;              // slope of the sigmoid
	double      activations[2];     // previous and current activations
    uint8_t     numEdges;           // number of incoming edges
    Edge        edges[];            // array of incoming edges
} Node;


typedef struct {
    uint8_t     numInputs;          // number of input nodes
	uint8_t     numOutputs;	        // number of output nodes
    uint8_t     activationIndex;    // index into the activations array
    uint8_t     numNodes;           // total number of nodes
    Node*       nodes[];            // array of node pointers
} Network;

#endif // network_h
