
/*!
 *  \file   ManualEvalOp.hpp
 *  \brief  Definition of the type ManualEvalOp.
 *  \author Vinod Valsalam
 *  $Revision: $
 *  $Date: $
 */

#ifndef ManualEvalOp_hpp
#define ManualEvalOp_hpp

#include "beagle/NN.hpp"
#include <string>
#include <vector>
#include "VizRobotEvalOp.hpp"

namespace Beagle
{
namespace NN
{


/*!
 *  \class ManualEvalOp ManualEvalOp.hpp "ManualEvalOp.hpp"
 *  \brief Double pole balancing evaluation operator for neural networks (Markov version)
 *  \ingroup NNF
 */
class ManualEvalOp : public VizRobotEvalOp
{

public:

	//! ManualEvalOp allocator type.
	typedef AllocatorT<ManualEvalOp,VizRobotEvalOp::Alloc>
	Alloc;
	//! ManualEvalOp handle type.
	typedef PointerT<ManualEvalOp,VizRobotEvalOp::Handle>
	Handle;
	//! ManualEvalOp bag type.
	typedef ContainerT<ManualEvalOp,VizRobotEvalOp::Bag>
	Bag;

	explicit ManualEvalOp(const std::string& inName="NN-ManualEvalOp");
	virtual ~ManualEvalOp()
    { }

	virtual FitnessIndexed::Handle evaluate(NN::Graph& ioGraph, Context& ioContext);

};

}
}


#endif // ManualEvalOp_hpp
