
#include "explorer/Explorer.hpp"


int main(int argc, char *argv[])
{
	Explorer::Application lApp(argc, argv);

	try {
		// Build a system with Beagle and Explorer packages
		Beagle::System::Handle lSystem = new Beagle::System;
        lSystem->addPackage(new Beagle::PackageBase);
        lSystem->addPackage(new Explorer::PackageBase);

        // Add optional history component
		lSystem->addComponent(new Beagle::History);

        // Setup a Qt main window.
		Explorer::MainWindow* lMainWindow = new Explorer::MainWindow(lSystem);
		lMainWindow->show();

	} catch (Beagle::Exception& inException) {
		inException.terminate(std::cerr);
	} catch (std::exception& inException) {
		std::cerr << "Standard exception caught:" << std::endl << std::flush;
		std::cerr << inException.what() << std::endl << std::flush;
		abort();
	} catch (...) {
        std::cerr << "Unknown exception caught!" << std::endl << std::flush;
		abort();
	}

	return lApp.exec();
}

