
#ifndef Explorer_ENSO_GraphSettings_hpp
#define Explorer_ENSO_GraphSettings_hpp

#include <QSvgRenderer>
#include <beagle/ENSO.hpp>

#include "explorer/DisplaySettings.hpp"


namespace Explorer
{
namespace ENSO
{

class GraphSettings : public DisplaySettings
{

	Q_OBJECT

public:

	GraphSettings(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~GraphSettings()
    { }

	virtual void setup(const Beagle::ENSO::Individual& inIndividual, const Beagle::Context& inContext);

public slots:

	virtual void updateView();

protected:

	QSvgRenderer*             mSvgRenderer;

    void writeGraph(std::ostream& outStream, const Beagle::ENSO::Individual& inIndividual, const Beagle::Context& inContext) const;
    void processSvg(PACC::XML::Document& ioParser) const;
    QColor getColor(double inValue, double inMinValue, double inMaxValue) const;

};

}
}


#endif // Explorer_ENSO_GraphSettings_hpp
