
#ifndef Explorer_ENSO_GraphVertex_hpp
#define Explorer_ENSO_GraphVertex_hpp

#include "explorer/DisplayNode.hpp"
#include "explorer/ENSO/Vertex.hpp"


namespace Explorer
{
namespace ENSO
{

class GraphVertex : public DisplayNode
{

public:

	explicit GraphVertex(Vertex::Handle inVertex, unsigned int inVertexId);

	virtual void paint(QPainter *ioPainter, const QStyleOptionGraphicsItem *inOption, QWidget *inWidget);

	virtual const DisplayObject::Handle getDisplayObject() const;
	virtual DisplayObject::Handle getDisplayObject();

private:

    Vertex::Handle  mVertex;        //!< The graph vertex that is displayed.
    unsigned int    mVertexId;      //!< VertexId of the Beagle::ENSO::Node in the genotype tree.

};

}
}


inline const Explorer::DisplayObject::Handle Explorer::ENSO::GraphVertex::getDisplayObject() const
{
	Beagle_StackTraceBeginM();

	return mVertex;

	Beagle_StackTraceEndM("const DisplayObject::Handle ENSO::GraphVertex::getDisplayObject() const");
}


inline Explorer::DisplayObject::Handle Explorer::ENSO::GraphVertex::getDisplayObject()
{
	Beagle_StackTraceBeginM();

	return mVertex;

	Beagle_StackTraceEndM("DisplayObject::Handle ENSO::GraphVertex::getDisplayObject()");
}


#endif // Explorer_ENSO_GraphVertex_hpp
