
#ifndef Explorer_ENSO_NNInteraction_hpp
#define Explorer_ENSO_NNInteraction_hpp

#include <beagle/ENSO.hpp>

#include "explorer/AllocatorT.hpp"
#include "explorer/Interaction.hpp"
#include "explorer/ENSO/InteractionData.hpp"
#include "explorer/NN/Interaction.hpp"


namespace Explorer
{
namespace ENSO
{

/*!
 *  \brief The class that enables evolution to interact with the GUI,
 *  specialized for the ENSO module.
 */
class NNInteraction : public Explorer::NN::Interaction
{

public:

	//! ENSO::NNInteraction allocator type.
	typedef Beagle::AllocatorT<ENSO::NNInteraction,Explorer::NN::Interaction::Alloc>
    Alloc;
	//! ENSO::NNInteraction handle type.
	typedef Beagle::PointerT<ENSO::NNInteraction,Explorer::NN::Interaction::Handle>
    Handle;
	//! ENSO::NNInteraction bag type.
	typedef Beagle::ContainerT<ENSO::NNInteraction,Explorer::NN::Interaction::Bag>
    Bag;

	NNInteraction();
	virtual ~NNInteraction()
    { }

	virtual void setup(Beagle::System::Handle ioSystem);
    virtual void setupStatusIndicators(QWidget* inParent, QVector< QVector<QWidget*> >& outStatusIndicators);
    virtual void setupDisplayIndicators(QWidget* inParent, QVector<QWidget*>& outDisplayIndicators);

	virtual void update(const Beagle::ENSO::Individual& inIndividual, const Beagle::Context& inContext);

	virtual void closeEvent(QCloseEvent *event);

protected:

    static ENSO::InteractionData&   mENSOInteractionData;

};

}
}

#endif // Explorer_ENSO_NNInteraction_hpp
