
#ifndef Explorer_ENSO_PackageBase_hpp
#define Explorer_ENSO_PackageBase_hpp

#include "beagle/ENSO.hpp"


namespace Explorer
{
namespace ENSO
{

class PackageBase : public Beagle::Package
{

public:

	//! ENSO::PackageBase allocator type.
	typedef Beagle::AllocatorT< PackageBase, Beagle::Package::Alloc > Alloc;
	//! ENSO::PackageBase handle type.
	typedef Beagle::PointerT< PackageBase, Beagle::Package::Handle > Handle;
	//! ENSO::PackageBase bag type.
	typedef Beagle::ContainerT< PackageBase, Beagle::Package::Bag > Bag;

	PackageBase(void);

	virtual void                  configure(Beagle::System& ioSystem);
	virtual Beagle::Package::Bag  listDependencies(void);

};

}
}

#endif // Explorer_ENSO_PackageBase_hpp
