
#ifndef Explorer_ENSO_TreeNode_hpp
#define Explorer_ENSO_TreeNode_hpp

#include "explorer/DisplayNode.hpp"
#include "explorer/ENSO/Node.hpp"


namespace Explorer
{
namespace ENSO
{

class TreeNode : public DisplayNode
{

public:

	explicit TreeNode(Node::Handle inNode, unsigned int inIndex);

	virtual void paint(QPainter *ioPainter, const QStyleOptionGraphicsItem *inOption, QWidget *inWidget);

	virtual const DisplayObject::Handle getDisplayObject() const;
	virtual DisplayObject::Handle getDisplayObject();

private:

    Node::Handle    mNode;          //!< The node that is displayed.
    unsigned int    mIndex;         //!< Index of the Beagle::ENSO::Node in the genotype tree.

};

}
}


inline const Explorer::DisplayObject::Handle Explorer::ENSO::TreeNode::getDisplayObject() const
{
	Beagle_StackTraceBeginM();

	return mNode;

	Beagle_StackTraceEndM("const DisplayObject::Handle ENSO::TreeNode::getDisplayObject() const");
}


inline Explorer::DisplayObject::Handle Explorer::ENSO::TreeNode::getDisplayObject()
{
	Beagle_StackTraceBeginM();

	return mNode;

	Beagle_StackTraceEndM("DisplayObject::Handle ENSO::TreeNode::getDisplayObject()");
}


#endif // Explorer_ENSO_TreeNode_hpp
