
#ifndef Explorer_ENSO_TreeSettings_hpp
#define Explorer_ENSO_TreeSettings_hpp

#include <QSvgRenderer>
#include <beagle/ENSO.hpp>

#include "explorer/DisplaySettings.hpp"


namespace Explorer
{
namespace ENSO
{

class TreeSettings : public DisplaySettings
{

	Q_OBJECT

public:

	TreeSettings(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~TreeSettings()
    { }

	virtual void setup(const Beagle::ENSO::Individual& inIndividual, const Beagle::Context& inContext);

public slots:

	virtual void updateView();

protected:

	QSvgRenderer*             mSvgRenderer;

    void writeTree(std::ostream& outStream, const Beagle::ENSO::Tree& inTree, const Beagle::Context& inContext) const;
    void processSvg(PACC::XML::Document& ioParser) const;

};

}
}


#endif // Explorer_ENSO_TreeSettings_hpp
