
#ifndef Explorer_GP_PackageBase_hpp
#define Explorer_GP_PackageBase_hpp

#include "beagle/Beagle.hpp"


namespace Explorer
{
namespace GP
{

class PackageBase : public Beagle::Package
{

public:

	//! GP::PackageBase allocator type.
	typedef Beagle::AllocatorT< PackageBase, Beagle::Package::Alloc > Alloc;
	//! GP::PackageBase handle type.
	typedef Beagle::PointerT< PackageBase, Beagle::Package::Handle > Handle;
	//! GP::PackageBase bag type.
	typedef Beagle::ContainerT< PackageBase, Beagle::Package::Bag > Bag;

	PackageBase(void);

	virtual void                  configure(Beagle::System& ioSystem);
	virtual Beagle::Package::Bag  listDependencies(void);

};

}
}

#endif // Explorer_GP_PackageBase_hpp
