
#ifndef Explorer_NN_Interaction_hpp
#define Explorer_NN_Interaction_hpp

#include <beagle/NN.hpp>

#include "explorer/AllocatorT.hpp"
#include "explorer/Interaction.hpp"
#include "explorer/NN/InteractionData.hpp"


namespace Explorer
{
namespace NN
{

/*!
 *  \brief The class that enables evolution to interact with the GUI,
 *  specialized for the NN module.
 */
class Interaction : public Explorer::Interaction
{

public:

	//! NN::Interaction allocator type.
	typedef Beagle::AllocatorT<NN::Interaction,Explorer::Interaction::Alloc>
    Alloc;
	//! NN::Interaction handle type.
	typedef Beagle::PointerT<NN::Interaction,Explorer::Interaction::Handle>
    Handle;
	//! NN::Interaction bag type.
	typedef Beagle::ContainerT<NN::Interaction,Explorer::Interaction::Bag>
    Bag;

	Interaction();
	virtual ~Interaction()
    { }

	virtual void setup(Beagle::System::Handle ioSystem);
    virtual void setupStatusIndicators(QWidget* inParent, QVector< QVector<QWidget*> >& outStatusIndicators);
    virtual void setupDisplayIndicators(QWidget* inParent, QVector<QWidget*>& outDisplayIndicators);

	virtual void update(const Beagle::NN::Graph& inGraph, const Beagle::Context& inContext);

	virtual void closeEvent(QCloseEvent *event);

protected:

    static NN::InteractionData&    mNNInteractionData;

};

}
}

#endif // Explorer_NN_Interaction_hpp
