
#ifndef Explorer_NN_NetworkNode_hpp
#define Explorer_NN_NetworkNode_hpp

#include "explorer/DisplayNode.hpp"
#include "explorer/NN/Node.hpp"


namespace Explorer
{
namespace NN
{

class NetworkNode : public DisplayNode
{

public:

	explicit NetworkNode(Node::Handle inNode=NULL);

	virtual void paint(QPainter *ioPainter, const QStyleOptionGraphicsItem *inOption, QWidget *inWidget);

	virtual const DisplayObject::Handle getDisplayObject() const;
	virtual DisplayObject::Handle getDisplayObject();

private:

    Node::Handle    mNode;          //!< The node that is displayed.
    unsigned int    mIdentifier;    //!< Identifier of the Beagle::NN::Node.

};

}
}


inline const Explorer::DisplayObject::Handle Explorer::NN::NetworkNode::getDisplayObject() const
{
	Beagle_StackTraceBeginM();

	return mNode;

	Beagle_StackTraceEndM("const DisplayObject::Handle NN::NetworkNode::getDisplayObject() const");
}


inline Explorer::DisplayObject::Handle Explorer::NN::NetworkNode::getDisplayObject()
{
	Beagle_StackTraceBeginM();

	return mNode;

	Beagle_StackTraceEndM("DisplayObject::Handle NN::NetworkNode::getDisplayObject()");
}


#endif // Explorer_NN_NetworkNode_hpp
