
#ifndef Explorer_NN_NetworkSettings_hpp
#define Explorer_NN_NetworkSettings_hpp

#include <QSvgRenderer>
#include <beagle/NN.hpp>

#include "explorer/DisplaySettings.hpp"


namespace Explorer
{
namespace NN
{

class NetworkSettings : public DisplaySettings
{

	Q_OBJECT

public:

	NetworkSettings(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~NetworkSettings()
    { }

	virtual void setup(const Beagle::NN::Graph& inGraph, const Beagle::Context& inContext);

public slots:

	virtual void updateView();

protected:

	QSvgRenderer*             mSvgRenderer;

    void writeGraph(std::ostream& outStream, const Beagle::NN::Graph& inGraph, const Beagle::Context& inContext) const;
    void processSvg(PACC::XML::Document& ioParser) const;
    QColor getColor(double inValue, double inMinValue, double inMaxValue) const;

};

}
}


#endif // Explorer_NN_NetworkSettings_hpp
