
#ifndef Explorer_NN_PackageBase_hpp
#define Explorer_NN_PackageBase_hpp

#include "beagle/NN.hpp"


namespace Explorer
{
namespace NN
{

class PackageBase : public Beagle::Package
{

public:

	//! NN::PackageBase allocator type.
	typedef Beagle::AllocatorT< PackageBase, Beagle::Package::Alloc > Alloc;
	//! NN::PackageBase handle type.
	typedef Beagle::PointerT< PackageBase, Beagle::Package::Handle > Handle;
	//! NN::PackageBase bag type.
	typedef Beagle::ContainerT< PackageBase, Beagle::Package::Bag > Bag;

	PackageBase(void);

	virtual void                  configure(Beagle::System& ioSystem);
	virtual Beagle::Package::Bag  listDependencies(void);

};

}
}

#endif // Explorer_NN_PackageBase_hpp
