
#ifndef Explorer_NN_Plot_hpp
#define Explorer_NN_Plot_hpp

#include "beagle/NN.hpp"
#include <QVector>
#include <qwt_plot.h>
#include <qwt_plot_curve.h>
#include "explorer/NN/PlotData.hpp"


namespace Explorer
{
namespace NN
{

class Plot : public QwtPlot 
{

    Q_OBJECT

public:

    Plot(const NN::PlotData::Data& inData, QWidget* inParent = 0);

    void updateView(const NN::PlotData::Data& inData);

private slots:

    void showCurve(QwtPlotItem *inItem, bool inOn);

signals:

    void closed();

protected:

	virtual void closeEvent(QCloseEvent *event);

    QVector<QwtPlotCurve*>  mCurves;    //!< The curves in this plot.

};

}
}


#endif // Explorer_NN_Plot_hpp
