
#include "explorer/NN.hpp"

using namespace Explorer;


NN::Individual::ModuleMap NN::Individual::smModuleMap;
std::string               NN::Individual::smDisplayName = "Modules";
float                     NN::Individual::smMinDisplayValue = FLT_MAX;
float                     NN::Individual::smMaxDisplayValue = -FLT_MAX;


NN::Individual::Individual() :
		mDisplayValue(-FLT_MAX)
{}


/*!
 *  \brief Reset information in members.
 */
void NN::Individual::reset()
{
	Beagle_StackTraceBeginM();

	Explorer::Individual::reset();

	smModuleMap.clear();
	smMinDisplayValue = FLT_MAX;
	smMaxDisplayValue = -FLT_MAX;
	mDisplayValue = -FLT_MAX;

	Beagle_StackTraceEndM("void NN::Individual::reset()");
}


/*!
 *  \brief Setup the member variables with data from the provided Beagle Individual.
 */
void NN::Individual::setup(Beagle::Individual::Handle inIndividual, Beagle::System& ioSystem)
{
	Beagle_StackTraceBeginM();

	Explorer::Individual::setup(inIndividual, ioSystem);

	//   if (inIndividual != NULL) {
	//     Beagle::NN::Individual::Handle lIndividual = Beagle::castHandleT<Beagle::NN::Individual>(inIndividual);
	//     unsigned int lPredictorId = (*lIndividual)[0]->getNode(0).getPredictDual();
	//     if (lPredictorId < UINT_MAX) {
	//       NN::Individual::ModuleMap::const_iterator lIter = smModuleMap.find(lPredictorId);
	//       if (lIter == smModuleMap.end()) {
	//         unsigned int lNextValue = smModuleMap.size();
	//         lIter = smModuleMap.insert(NN::Individual::ModuleMap::value_type(lPredictorId, lNextValue)).first;
	//         mDisplayValue = (float)lNextValue;

	//         // Keep track of the min and max display values.
	//         if (lNextValue == 0) smMinDisplayValue = mDisplayValue;
	//         smMaxDisplayValue = mDisplayValue;
	//       }
	//       else {
	//         mDisplayValue = (float)(lIter->second);
	//       }
	//     }
	//     else {
	//       mDisplayValue = -FLT_MAX;
	//     }
	//   }

	Beagle_StackTraceEndM("void NN::Individual::setup(Beagle::Individual::Handle inIndividual, Beagle::System& ioSystem)");
}

