
#ifndef Explorer_SN_FunctionNode_hpp
#define Explorer_SN_FunctionNode_hpp

#include "explorer/DisplayNode.hpp"
#include "explorer/SN/Function.hpp"


namespace Explorer
{
namespace SN
{

class FunctionNode : public DisplayNode
{

public:

	explicit FunctionNode(Function::Handle inFunction=NULL);

	virtual void paint(QPainter *ioPainter, const QStyleOptionGraphicsItem *inOption, QWidget *inWidget);
    virtual QRectF boundingRect() const;

	virtual const DisplayObject::Handle getDisplayObject() const;
	virtual DisplayObject::Handle getDisplayObject();

private:

    Function::Handle    mFunction;          //!< The function that is displayed.
    QRectF              mBoundingRect;      //!< The current bounding rectangle of the node.

};

}
}


inline const Explorer::DisplayObject::Handle Explorer::SN::FunctionNode::getDisplayObject() const
{
	Beagle_StackTraceBeginM();

	return mFunction;

	Beagle_StackTraceEndM("const DisplayObject::Handle SN::FunctionNode::getDisplayObject() const");
}


inline Explorer::DisplayObject::Handle Explorer::SN::FunctionNode::getDisplayObject()
{
	Beagle_StackTraceBeginM();

	return mFunction;

	Beagle_StackTraceEndM("DisplayObject::Handle SN::FunctionNode::getDisplayObject()");
}


inline QRectF Explorer::SN::FunctionNode::boundingRect() const
{
	Beagle_StackTraceBeginM();

	return mBoundingRect;

	Beagle_StackTraceEndM("const QRectF SN::FunctionNode::boundingRect() const");
}


#endif // Explorer_SN_FunctionNode_hpp
