
#ifndef Explorer_SN_Interaction_hpp
#define Explorer_SN_Interaction_hpp

#include <beagle/SN.hpp>

#include "explorer/AllocatorT.hpp"
#include "explorer/Interaction.hpp"
#include "explorer/SN/InteractionData.hpp"


namespace Explorer
{
namespace SN
{

/*!
 *  \brief The class that enables evolution to interact with the GUI,
 *  specialized for the SN module.
 */
class Interaction : public Explorer::Interaction
{

public:

	//! SN::Interaction allocator type.
	typedef Beagle::AllocatorT<SN::Interaction,Explorer::Interaction::Alloc>
    Alloc;
	//! SN::Interaction handle type.
	typedef Beagle::PointerT<SN::Interaction,Explorer::Interaction::Handle>
    Handle;
	//! SN::Interaction bag type.
	typedef Beagle::ContainerT<SN::Interaction,Explorer::Interaction::Bag>
    Bag;

	Interaction();
	virtual ~Interaction()
    { }

	virtual void setup(Beagle::System::Handle ioSystem);
    virtual void setupDisplayIndicators(QWidget* inParent, QVector<QWidget*>& outDisplayIndicators);

	virtual void update(const Beagle::SN::Network& inNetwork, const Beagle::Context& inContext);

	virtual void closeEvent(QCloseEvent *event);

protected:

    static SN::InteractionData&    mSNInteractionData;

};

}
}

#endif // Explorer_SN_Interaction_hpp
