
#ifndef Explorer_SN_NetworkSettings_hpp
#define Explorer_SN_NetworkSettings_hpp

#include <QSvgRenderer>
#include <beagle/SN.hpp>

#include "explorer/DisplaySettings.hpp"


namespace Explorer
{
namespace SN
{

class NetworkSettings : public DisplaySettings
{

	Q_OBJECT

public:

	NetworkSettings(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~NetworkSettings()
    { }

	virtual void setup(const Beagle::SN::Network& inNetwork, const Beagle::Context& inContext);

public slots:

	virtual void updateView();

protected slots:

	virtual void scale(int inScale);

protected:

	QSvgRenderer*             mSvgRenderer;

};

}
}


#endif // Explorer_SN_NetworkSettings_hpp
