
#ifndef Explorer_SN_NetworkWidget_hpp
#define Explorer_SN_NetworkWidget_hpp

#include <beagle/SN.hpp>

#include "explorer/DisplayWidget.hpp"
#include "explorer/SN/NetworkSettings.hpp"


namespace Explorer
{
namespace SN
{

class NetworkWidget : public DisplayWidget
{

	Q_OBJECT

public:

	NetworkWidget(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~NetworkWidget()
	{ }

	virtual void reset();

	void setup(const Beagle::SN::Network& inNetwork, const Beagle::Context& inContext);
    bool setupComplete() const;

private:

    bool mSetupComplete;

};

}
}


inline bool Explorer::SN::NetworkWidget::setupComplete() const
{
	Beagle_StackTraceBeginM();

    return mSetupComplete;

	Beagle_StackTraceEndM("bool SN::NetworkWidget::setupComplete() const");
}


#endif // Explorer_SN_NetworkWidget_hpp
