
#ifndef Explorer_SN_PackageBase_hpp
#define Explorer_SN_PackageBase_hpp

#include "beagle/SN.hpp"


namespace Explorer
{
namespace SN
{

class PackageBase : public Beagle::Package
{

public:

	//! SN::PackageBase allocator type.
	typedef Beagle::AllocatorT< PackageBase, Beagle::Package::Alloc > Alloc;
	//! SN::PackageBase handle type.
	typedef Beagle::PointerT< PackageBase, Beagle::Package::Handle > Handle;
	//! SN::PackageBase bag type.
	typedef Beagle::ContainerT< PackageBase, Beagle::Package::Bag > Bag;

	PackageBase(void);

	virtual void                  configure(Beagle::System& ioSystem);
	virtual Beagle::Package::Bag  listDependencies(void);

};

}
}

#endif // Explorer_SN_PackageBase_hpp
