
#include "explorer/SN.hpp"

using namespace Explorer;


SN::NetworkWidget::NetworkWidget(QWidget* inParent, Qt::WFlags inFlags) :
		DisplayWidget(0, "NetworkWidget", inParent, inFlags),
        mSetupComplete(false)
{
	Beagle_StackTraceBeginM();

    mDisplaySettings = new NetworkSettings(this);
    DisplayWidget::setup();

	Beagle_StackTraceEndM("NetworkWidget::NetworkWidget(QWidget* inParent, Qt::WFlags inFlags)");
}


void SN::NetworkWidget::reset()
{
	Beagle_StackTraceBeginM();

    DisplayWidget::reset();
    mSetupComplete = false;

	Beagle_StackTraceEndM("void SN::NetworkWidget::reset()");
}


void SN::NetworkWidget::setup(const Beagle::SN::Network& inNetwork, const Beagle::Context& inContext)
{
	Beagle_StackTraceBeginM();

	qobject_cast<NetworkSettings*>(mDisplaySettings)->setup(inNetwork, inContext);
    mSetupComplete = true;

	Beagle_StackTraceEndM("void SN::NetworkWidget::setup(const Beagle::SN::Network& inNetwork, const Beagle::Context& inContext)");
}
