
#ifndef ConfigurationTree_hpp
#define ConfigurationTree_hpp

#include <QDomDocument>
#include <QHash>
#include <QIcon>
#include <QTreeWidget>

/*!
 *  Class for editing OpenBEAGLE configuration files.
 *  Adapted from the DOM Bookmarks example included with Qt.
 */
class ConfigurationTree : public QTreeWidget
{

	Q_OBJECT

public:

	ConfigurationTree(QWidget* inParent=0);
	~ConfigurationTree()
	{ }

	bool read(QIODevice* inDevice);
	bool write(QIODevice* outDevice);

signals:

    void modified();

protected slots:

	void updateDomElement(QTreeWidgetItem* ioItem, int inColumn);

protected:

	void             parseDomElement(const QDomElement& inElement, QTreeWidgetItem* inParentItem=0);
	QTreeWidgetItem* createItem(const QDomNode& inNode, QTreeWidgetItem* inParentItem=0);

	QDomDocument                      mDomDocument;
	QHash<QTreeWidgetItem*, QDomNode> mDomNodeForItem;
	QIcon                             mElementIcon;
	QIcon                             mAttributeIcon;

};


#endif // ConfigurationTree_hpp
