
#ifndef Explorer_DisplayNode_hpp
#define Explorer_DisplayNode_hpp

#include <QWidget>
#include <QColor>
#include <QGraphicsItem>
#include <QPainter>
#include <QStyleOptionGraphicsItem>

#include "explorer/DisplayObject.hpp"


namespace Explorer
{

class DisplayNode : public QGraphicsItem
{

public:

	DisplayNode();
    virtual ~DisplayNode()
    { }

	virtual QRectF boundingRect() const;

	enum {Type = UserType + 1};
	int type () const;

	virtual const DisplayObject::Handle getDisplayObject() const = 0;

protected:

	QColor getOuterColor() const;
	QColor getOuterColor(int inNodeHueIndex, int inNodeSatIndex, int inNodeValIndex) const;
	QColor getInnerColor(const QColor& inOuterColor) const;
	QColor getInnerColor(const QColor& inOuterColor, int inNodeHueIndex, int inNodeSatIndex, int inNodeValIndex) const;

};

}


/*!
 *  \brief Enable the use of qgraphicsitem_cast with this item.
 */
inline int Explorer::DisplayNode::type() const
{
	Beagle_StackTraceBeginM();

	return Type;

	Beagle_StackTraceEndM("int DisplayNode::type() const");
}


#endif // Explorer_DisplayNode_hpp
