
#ifndef Explorer_DisplayObject_hpp
#define Explorer_DisplayObject_hpp

#include <beagle/Beagle.hpp>

namespace Explorer
{

class DisplayObject : public Beagle::Object
{

public:

	//! DisplayObject allocator type.
	typedef Beagle::AllocatorT<DisplayObject,Beagle::Object::Alloc>
	Alloc;
	//! DisplayObject handle type.
	typedef Beagle::PointerT<DisplayObject,Beagle::Object::Handle>
	Handle;
	//! DisplayObject bag type.
	typedef Beagle::ContainerT<DisplayObject,Beagle::Object::Bag>
	Bag;

	DisplayObject()
    { }
	virtual ~DisplayObject()
	{ }

	virtual void reset()
    { }
	virtual void update()
    { }

	virtual int         getDisplaySize() const;
	virtual std::string getDisplayName(int inIndex) const;
	virtual float       getDisplayValue(int inIndex) const;
	virtual float       getMinDisplayValue(int inIndex) const;
	virtual float       getMaxDisplayValue(int inIndex) const;

	virtual std::string getToolTip() const;
};

}


inline int Explorer::DisplayObject::getDisplaySize() const
{
	Beagle_StackTraceBeginM();

	return 1;

	Beagle_StackTraceEndM("int DisplayObject::getDisplaySize() const");
}


inline std::string Explorer::DisplayObject::getDisplayName(int inIndex) const
{
	Beagle_StackTraceBeginM();

	return "None";

	Beagle_StackTraceEndM("std::string DisplayObject::getDisplayName(int inIndex) const");
}


inline float Explorer::DisplayObject::getDisplayValue(int inIndex) const
{
	Beagle_StackTraceBeginM();

	return 0.0;

	Beagle_StackTraceEndM("float DisplayObject::getDisplayValue(int inIndex) const");
}


inline float Explorer::DisplayObject::getMinDisplayValue(int inIndex) const
{
	Beagle_StackTraceBeginM();

	return 0.0;

	Beagle_StackTraceEndM("float DisplayObject::getMinDisplayValue(int inIndex) const");
}


inline float Explorer::DisplayObject::getMaxDisplayValue(int inIndex) const
{
	Beagle_StackTraceBeginM();

	return 0.0;

	Beagle_StackTraceEndM("float DisplayObject::getMaxDisplayValue(int inIndex) const");
}


inline std::string Explorer::DisplayObject::getToolTip() const
{
	Beagle_StackTraceBeginM();

	return std::string();

	Beagle_StackTraceEndM("std::string DisplayObject::getToolTip() const");
}


#endif // Explorer_DisplayObject_hpp
