
#ifndef Explorer_DisplayScene_hpp
#define Explorer_DisplayScene_hpp

#include <QGraphicsScene>

#include <beagle/Beagle.hpp>

#include "explorer/DisplayNode.hpp"

namespace Explorer
{

class DisplayScene : public QGraphicsScene
{

	Q_OBJECT

public:

	DisplayScene(QObject *parent = 0);
	virtual ~DisplayScene()
	{ }

	QList<DisplayNode*> getSelectedNodes() const;

	void  setNodeHueIndex(int inNodeHueIndex);
	void  setNodeSatIndex(int inNodeSatIndex);
	void  setNodeValIndex(int inNodeValIndex);
	void  setNodeBoundingSize(qreal inNodeBoundingSize);

	int getNodeHueIndex();
	int getNodeSatIndex();
	int getNodeValIndex();
	qreal getNodeBoundingSize();

signals:

	void nodeSelectionChanged();

private slots:

	void processSelection();

private:

	int   mNodeHueIndex;
	int   mNodeSatIndex;
	int   mNodeValIndex;
	qreal mNodeBoundingSize;

};

}


inline void Explorer::DisplayScene::setNodeHueIndex(int inNodeHueIndex)
{
	Beagle_StackTraceBeginM();

	mNodeHueIndex = inNodeHueIndex;

	Beagle_StackTraceEndM("void DisplayScene::setNodeHueIndex(int inNodeHueIndex)");
}


inline void Explorer::DisplayScene::setNodeSatIndex(int inNodeSatIndex)
{
	Beagle_StackTraceBeginM();

	mNodeSatIndex = inNodeSatIndex;

	Beagle_StackTraceEndM("void DisplayScene::setNodeSatIndex(int inNodeSatIndex)");
}


inline void Explorer::DisplayScene::setNodeValIndex(int inNodeValIndex)
{
	Beagle_StackTraceBeginM();

	mNodeValIndex = inNodeValIndex;

	Beagle_StackTraceEndM("void DisplayScene::setNodeValIndex(int inNodeValIndex)");
}


inline void Explorer::DisplayScene::setNodeBoundingSize(qreal inNodeBoundingSize)
{
	Beagle_StackTraceBeginM();

	mNodeBoundingSize = inNodeBoundingSize;

	Beagle_StackTraceEndM("void DisplayScene::setNodeBoundingSize(qreal inNodeBoundingSize)");
}


inline int Explorer::DisplayScene::getNodeHueIndex()
{
	Beagle_StackTraceBeginM();

	return mNodeHueIndex;

	Beagle_StackTraceEndM("int DisplayScene::getNodeHueIndex()");
}


inline int Explorer::DisplayScene::getNodeSatIndex()
{
	Beagle_StackTraceBeginM();

	return mNodeSatIndex;

	Beagle_StackTraceEndM("int DisplayScene::getNodeSatIndex()");
}


inline int Explorer::DisplayScene::getNodeValIndex()
{
	Beagle_StackTraceBeginM();

	return mNodeValIndex;

	Beagle_StackTraceEndM("int DisplayScene::getNodeValIndex()");
}


inline qreal Explorer::DisplayScene::getNodeBoundingSize()
{
	Beagle_StackTraceBeginM();

	return mNodeBoundingSize;

	Beagle_StackTraceEndM("qreal DisplayScene::getNodeBoundingSize()");
}


#endif // Explorer_DisplayScene_hpp
