
#ifndef Explorer_DisplaySettings_hpp
#define Explorer_DisplaySettings_hpp

#include <QWidget>
#include <QGraphicsView>
#include <beagle/Beagle.hpp>

#include "explorer/DisplayScene.hpp"
#include "explorer/DisplayObject.hpp"
#include "designer/ui_DisplaySettings.h"


namespace Explorer
{

class DisplaySettings : public QWidget, protected Ui::DisplaySettings
{

	Q_OBJECT

public:

	DisplaySettings(QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~DisplaySettings()
	{ }

	virtual void reset();
	virtual void setup();

	QGraphicsView* getView();

public slots:

	virtual void updateView() = 0;

protected slots:

	virtual void scale(int inScale);
	virtual void updateNodeHue(int inNodeHueIndex);
	virtual void updateNodeSat(int inNodeSatIndex);
	virtual void updateNodeVal(int inNodeValIndex);

protected:

	QGraphicsView*          mView;            //!< The graphics view used for display
	DisplayScene*           mScene;           //!< The scene containing the display nodes
	DisplayObject::Handle   mPrototypeObject; //!< A prototype object used for managing color settings etc.

};

}


inline QGraphicsView* Explorer::DisplaySettings::getView()
{
	Beagle_StackTraceBeginM();

	return mView;

	Beagle_StackTraceEndM("QGraphicsView* DisplaySettings::getView()");
}


#endif // Explorer_DisplaySettings_hpp
