
#ifndef Explorer_DisplayWidget_hpp
#define Explorer_DisplayWidget_hpp

#include <QWidget>
#include <QString>
#include <beagle/Beagle.hpp>

#include "explorer/DisplaySettings.hpp"
#include "designer/ui_DisplayWidget.h"


namespace Explorer
{

class DisplayWidget : public QWidget, private Ui::DisplayWidget
{

	Q_OBJECT

public:

	DisplayWidget(DisplaySettings* inDisplaySettings=0, QString inName="DisplayWidget",
                  QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~DisplayWidget()
	{ }

	virtual void reset();
	virtual void setup();
	virtual void updateView();

signals:

    void closed();

protected:

	virtual void closeEvent(QCloseEvent *event);

	virtual void readSettings();
	virtual void writeSettings();

	DisplaySettings*    mDisplaySettings;
    QString             mName;

};

}

#endif // Explorer_DisplayWidget_hpp
