
#ifndef Explorer_EvolutionTab_hpp
#define Explorer_EvolutionTab_hpp

#include <QWidget>
#include <beagle/Beagle.hpp>

#include "designer/ConfigurationTree.hpp"
#include "designer/ui_EvolutionTab.h"

namespace Explorer
{

class EvolutionTab : public QWidget, private Ui::EvolutionTab
{

	Q_OBJECT

public:

	EvolutionTab(Beagle::System::Handle ioSystem, QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~EvolutionTab()
	{ }

public slots:

	void openConfiguration();
	void saveConfiguration();
	void saveConfigurationAs();

protected slots:

    void setConfigurationModified();
    virtual void evolve();

protected:

	virtual void closeEvent(QCloseEvent *event);

	virtual void readSettings();
	virtual void writeSettings();

private:

    Beagle::System::Handle  mSystem;
    Beagle::Evolver::Handle mEvolver;
	ConfigurationTree*      mConfigurationTree;
    QString                 mConfigurationFile;

};

}


#endif // Explorer_EvolutionTab_hpp
