
#ifndef Explorer_GenealogySettings_hpp
#define Explorer_GenealogySettings_hpp

#include <QSvgRenderer>

#include "explorer/HistorySettings.hpp"


namespace Explorer
{

class GenealogySettings : public HistorySettings
{

	Q_OBJECT

public:

	GenealogySettings(History::Handle inHistory=NULL, QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~GenealogySettings()
    { }

	void setVivariumSelections(HistoryEntry::Bag::Handle inVivariumSelections);

public slots:

	virtual void updateView();

protected:

	HistoryEntry::Bag::Handle mVivariumSelections;
	QSvgRenderer*             mSvgRenderer;

	void processSvg(PACC::XML::Document& ioParser) const;

};

}


#endif // Explorer_GenealogySettings_hpp
