
#ifndef Explorer_HistoryNode_hpp
#define Explorer_HistoryNode_hpp

#include "explorer/DisplayNode.hpp"
#include "explorer/HistoryEntry.hpp"


namespace Explorer
{

class HistoryNode : public DisplayNode
{

public:

	explicit HistoryNode(HistoryEntry::Handle inHistoryEntry=NULL);

	virtual const DisplayObject::Handle getDisplayObject() const;
	const HistoryEntry::Handle getHistoryEntry() const;

protected:

	HistoryEntry::Handle mHistoryEntry;

};

}


inline const Explorer::HistoryEntry::Handle Explorer::HistoryNode::getHistoryEntry() const
{
	Beagle_StackTraceBeginM();

	return mHistoryEntry;

	Beagle_StackTraceEndM("const HistoryEntry::Handle HistoryNode::getHistoryEntry() const");
}


inline const Explorer::DisplayObject::Handle Explorer::HistoryNode::getDisplayObject() const
{
	Beagle_StackTraceBeginM();

	return mHistoryEntry->getIndividual();

	Beagle_StackTraceEndM("const DisplayObject::Handle HistoryNode::getDisplayObject() const");
}


#endif // Explorer_HistoryNode_hpp
