
#ifndef Explorer_HistorySettings_hpp
#define Explorer_HistorySettings_hpp

#include <QWidget>
#include <QGraphicsView>
#include <QLabel>
#include <QSpinBox>
#include <beagle/Beagle.hpp>

#include "explorer/History.hpp"
#include "explorer/HistoryEntry.hpp"
#include "explorer/DisplaySettings.hpp"


namespace Explorer
{

class HistorySettings : public DisplaySettings
{

	Q_OBJECT

public:

	HistorySettings(History::Handle inHistory=NULL, QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~HistorySettings()
	{ }

	virtual void setup();

	HistoryEntry::Bag::Handle getSelectedHistoryEntries() const;

protected:

    QLabel*             mAncestryLabel;
    QSpinBox*           mAncestrySpin;
    QLabel*             mDescendancyLabel;
    QSpinBox*           mDescendancySpin;

	History::Handle     mHistory;         //!< History data to be displayed

};

}


#endif // Explorer_HistorySettings_hpp
