
#ifndef Explorer_HistoryTab_hpp
#define Explorer_HistoryTab_hpp

#include <QWidget>
#include <beagle/Beagle.hpp>

#include "explorer/History.hpp"
#include "explorer/VivariumSettings.hpp"
#include "explorer/GenealogySettings.hpp"
#include "designer/ui_HistoryTab.h"

namespace Explorer
{

class HistoryTab : public QWidget, private Ui::HistoryTab
{

	Q_OBJECT

public:

	HistoryTab(Beagle::System::Handle ioSystem, QWidget* inParent=0, Qt::WFlags inFlags=0);
	virtual ~HistoryTab()
	{ }

	void readWithSystem(PACC::XML::ConstIterator inIter, Beagle::System& ioSystem);

	void reset();
	void setup();

public slots:

	void activateView(int inTabIndex);
	void scheduleGenealogyUpdate();

protected:

	virtual void closeEvent(QCloseEvent *event);

	virtual void readSettings();
	virtual void writeSettings();

private:

	History::Handle    mHistory;
	VivariumSettings*  mVivariumSettings;
	GenealogySettings* mGenealogySettings;
	bool               mGenealogyUpdateScheduled;

};

}


#endif // Explorer_HistoryTab_hpp
