
#ifndef Explorer_Interaction_hpp
#define Explorer_Interaction_hpp

#include <beagle/Beagle.hpp>

#include "explorer/InteractionData.hpp"


namespace Explorer
{

/*!
 *  \brief The class that enables evolution to interact with the GUI.
 */
class Interaction : public Beagle::Object
{

public:

	//! Interaction allocator type.
	typedef Beagle::AllocatorT<Interaction,Beagle::Object::Alloc>
	Alloc;
	//! Interaction handle type.
	typedef Beagle::PointerT<Interaction,Beagle::Object::Handle>
	Handle;
	//! Interaction bag type.
	typedef Beagle::ContainerT<Interaction,Beagle::Object::Bag>
	Bag;

	Interaction();
	virtual ~Interaction()
    { }

	virtual void setup(Beagle::System::Handle ioSystem);
    virtual void setupStatusIndicators(QWidget* inParent, QVector< QVector<QWidget*> >& outStatusIndicators);
    virtual void setupDisplayIndicators(QWidget* inParent, QVector<QWidget*>& outDisplayIndicators);

	virtual void update(const Beagle::Context& inContext);

	virtual void closeEvent(QCloseEvent *event);

protected:

    static InteractionData&    mInteractionData;
    
};

}


#endif // Explorer_Interaction_hpp
