
#ifndef Explorer_PackageBase_hpp
#define Explorer_PackageBase_hpp

#include "beagle/Beagle.hpp"
#include "explorer/Interaction.hpp"


namespace Explorer
{

class PackageBase : public Beagle::Package
{

public:

	//! PackageBase allocator type.
	typedef Beagle::AllocatorT< PackageBase, Beagle::Package::Alloc > Alloc;
	//! PackageBase handle type.
	typedef Beagle::PointerT< PackageBase, Beagle::Package::Handle > Handle;
	//! PackageBase bag type.
	typedef Beagle::ContainerT< PackageBase, Beagle::Package::Bag > Bag;

	PackageBase(void);

	virtual void                  configure(Beagle::System& ioSystem);
	virtual Beagle::Package::Bag  listDependencies(void);

};

}

#endif // Explorer_PackageBase_hpp
