
#include "explorer/Explorer.hpp"

using namespace Explorer;


Application::Application(int& argc, char** argv) :
		QApplication(argc, argv)
{}


Application::Application(int& argc, char** argv, bool GUIenabled) :
		QApplication(argc, argv, GUIenabled)
{}


bool Application::notify(QObject *ioReceiver, QEvent *ioEvent)
{
	try {
		return QApplication::notify(ioReceiver, ioEvent);
	} catch (Beagle::Exception& inException) {
		inException.terminate(std::cerr);
	} catch (std::exception& inException) {
		std::cerr << "Standard exception caught:" << std::endl << std::flush;
		std::cerr << inException.what() << std::endl << std::flush;
		abort();
	} catch (...) {
        std::cerr << "Unknown exception caught!" << std::endl << std::flush;
		abort();
	}

	return true;
}
