
#include <QSettings>

#include "explorer/Explorer.hpp"

using namespace Explorer;


ConfigureDialog::ConfigureDialog(QWidget* inParent, Qt::WindowFlags inFlags) :
		QDialog(inParent, inFlags),
		Ui::ConfigureDialog()
{
	Beagle_StackTraceBeginM();

	setupUi(this);

	Beagle_StackTraceEndM("ConfigureDialog::ConfigureDialog(QWidget* inParent, Qt::WFlags inFlags)");
}


bool ConfigureDialog::showDialog()
{
	Beagle_StackTraceBeginM();

	QSettings lSettings("OpenBEAGLE", "Explorer");

	QString lDotExe = lSettings.value("dotexe", QString("/usr/bin/dot")).toString();
	mDotExeEdit->setText(lDotExe);
	QString lNeatoExe = lSettings.value("neatoexe", QString("/usr/bin/neato")).toString();
	mNeatoExeEdit->setText(lNeatoExe);
	QString lCircoExe = lSettings.value("circoexe", QString("/usr/bin/circo")).toString();
	mCircoExeEdit->setText(lCircoExe);
	QString lSndrawExe = lSettings.value("sndrawexe", QString("/usr/bin/sndraw")).toString();
	mSndrawExeEdit->setText(lSndrawExe);

	if (exec() != Accepted)
		return false;

	lSettings.setValue("dotexe", mDotExeEdit->text());
	lSettings.setValue("neatoexe", mNeatoExeEdit->text());
	lSettings.setValue("circoexe", mCircoExeEdit->text());
	lSettings.setValue("sndrawexe", mSndrawExeEdit->text());

	return true;

	Beagle_StackTraceEndM("bool ConfigureDialog::showDialog()");
}
